<?php
namespace Financeiro\Repositories;

class Boletreceber extends \Doctrine\ORM\EntityRepository
{
    public function getParcelamento($cdfilial,$nrlanbolrec,$nrorg,$nrorigbolrec)
    {
        $sql = "SELECT
   BOLETRECEBER.CDFILIAL,
   BOLETRECEBER.NRLANBOLREC,
   BOLETRECEBER.CDCLIENTE,
   BOLETRECEBER.CDEMPRESA,
   BOLETRECEBER.NRPARCBOLREC,
   BOLETRECEBER.DTVENBOLREC,
   BOLETRECEBER.VRFINALBREC,
   BOLETRECEBER.CDMOTIPARC,
   BOLETRECEBER.IDSTATBREC,
   BOLETRECEBER.VRBOLREC,
   BOLETRECEBER.NRORIGBOLREC,
   BOLETRECEBER.CDREDUCONT,
   BOLETRECEBER.CDNOSNUMREC,
   BOLETRECEBER.CDCARTCOBBOL,
   BOLETRECEBER.CDINS1COBBOL,
   BOLETRECEBER.CDINS2COBBOL,
   BOLETRECEBER.QTDIAPROTBOL,
   BOLETRECEBER.IDIMPRBOLBOL,
   BOLETRECEBER.TXMENSBOLBOL,
   BOLETRECEBER.CDBARRAREC,
   BOLETRECEBER.DSLINHABARREC,
   MOTIVOPARC  .DSMOTIPARC,
   CONTCORR    .CDCONTCORR,
   BOLETRECEBER.IDSITUCNABR
FROM
   BOLETRECEBER,
   MOTIVOPARC,
   CONTCORR
WHERE
    (((BOLETRECEBER.NRORIGBOLREC IS NOT NULL) AND BOLETRECEBER.NRORIGBOLREC = :P_NRORIGBOLREC) OR
    ((BOLETRECEBER.CDFILIAL = :P_CDFILIAL) AND
     (BOLETRECEBER.NRLANBOLREC = :P_NRLANBOLREC))) AND
  (BOLETRECEBER .CDMOTIPARC = MOTIVOPARC.CDMOTIPARC(+)) AND
  (BOLETRECEBER .CDREDUCONT = CONTCORR  .CDREDUCONT(+)) AND
  (BOLETRECEBER.NRORG       = :P_NRORG)
ORDER BY
   BOLETRECEBER.CDFILIAL,
   BOLETRECEBER.NRLANBOLREC,
   BOLETRECEBER.NRPARCBOLREC

";
        $params = array(
            "P_NRORG"        => $nrorg,
            "P_NRLANBOLREC"     => $nrlanbolrec,
            "P_CDFILIAL"   => $cdfilial,
            "P_NRORIGBOLREC" =>$nrorigbolrec,
        );
        return $this->getEntityManager()->getConnection()->fetchAll($sql, $params);
    }

    public function getContaOriginalParcelamento($nrorg,$nrlanbolrec,$cdfilial){
        $sql = <<<SQL
        SELECT
          CR.CDFILIAL,
          CR.NRLANCTONF,
          NF.NRNOTAFISC,
          NF.CDSERIE,
          CR.NRSEQVENREC,
          CR.NRPARCELAREC,
          CR.DSCONTAREC,
          CR.DTORIGVENREC,
          CR.VRORIGREC,
          CR.DTATUAVENREC,
          CR.VRATUAREC,
          CR.NRLANBOLREC,
          CR.CDCLASSFINA,
          CR.CDEMPRESA,
          CR.CDFIMOVFLREC,
          CR.DTMOVFLUXO,
          CR.IDMOVFLUXO,
          CR.CDMOTIPARC,
          CR.QTDIASVENREC,
          CR.IDSTATREC,
          CR.CDFILIBOLREC,
          CR.CDTPCTRECEB,
          CR.CDFILIALDUP,
          CR.NRLANCTODUP,
          AJ.VRAJUSTE,
          CR.NRORG
        FROM
          NOTAFISCAL   NF,
          CONTARECEBER CR,
          (SELECT A.CDFILIAL, A.NRLANCTONF, A.NRSEQVENREC, A.NRPARCELAREC, A.NRORG,
                  SUM(DECODE(TA.IDAJUCTREC, 'A', A.VRAJUSTEREC, A.VRAJUSTEREC * (-1))) AS VRAJUSTE
             FROM AJCTRECEBER A, TIPOAJRECEBER TA
            WHERE A.NRORG      = TA.NRORG
            AND   A.CDAJUCTREC = TA.CDAJUCTREC
            GROUP BY A.CDFILIAL, A.NRLANCTONF, A.NRSEQVENREC, A.NRPARCELAREC, A.NRORG) AJ
        WHERE
          (CR.CDFILIBOLREC = :P_CDFILIAL       ) AND
          (CR.NRLANBOLREC  = :P_NRLANBOLREC    ) AND
          (CR.NRORG        = :P_NRORG          ) AND
          (NF.CDFILIAL     = CR.CDFILIAL       ) AND
          (NF.NRORG        = CR.NRORG          ) AND
          (NF.NRLANCTONF   = CR.NRLANCTONF     ) AND
          (CR.CDFILIAL     = AJ.CDFILIAL(+)    ) AND
          (CR.NRLANCTONF   = AJ.NRLANCTONF(+)  ) AND
          (CR.NRSEQVENREC  = AJ.NRSEQVENREC(+) ) AND
          (CR.NRPARCELAREC = AJ.NRPARCELAREC(+))
        ORDER BY
          CR.CDFILIAL,
          CR.NRLANCTONF,
          CR.NRSEQVENREC,
          CR.NRPARCELAREC
SQL;
        $params = array(
            "P_NRORG"        => $nrorg,
            "P_NRLANBOLREC"     => $nrlanbolrec,
            "P_CDFILIAL"   => $cdfilial,
        );
        return $this->getEntityManager()->getConnection()->fetchAll($sql, $params);
    }

    public function getRateioConta($nrorg,$nrlanbolrec,$cdfilial){
        $sql = <<<SQL
SELECT RR.CDFILIAL, RR.NRLANCTONF, RR.NRSEQVENREC, RR.NRPARCELAREC,
       RR.CDCENTCUST, RR.CDFIRATCTREC, RR.VRRATCCCTREC,RR.NRORG
 FROM  RATCTRECEBER RR,CONTARECEBER CR
WHERE
   RR.CDFILIAL = CR.CDFILIAL AND
   RR.NRLANCTONF = CR.NRLANCTONF AND
   RR.NRSEQVENREC = CR.NRSEQVENREC AND
   RR.NRPARCELAREC = CR.NRPARCELAREC AND
   CR.CDFILIBOLREC =:P_CDFILIAL AND
   CR.NRLANBOLREC = :P_NRLANBOLREC AND
   CR.NRORG       = :P_NRORG

SQL;
        $params = array(
                    "P_NRORG"        => $nrorg,
                    "P_NRLANBOLREC"     => $nrlanbolrec,
                    "P_CDFILIAL"   => $cdfilial,
                   );
        return $this->getEntityManager()->getConnection()->fetchAll($sql, $params);
    }

    public function getMaxParcela($nrorg,$nrlanbolrec,$cdfilial,$nrorigbolrec){
        $sql = <<<SQL
SELECT
   MAX(BR.NRPARCBOLREC) ULTPARC
FROM
   BOLETRECEBER BR
WHERE
  ((BR.CDFILIAL    = :P_CDFILIAL AND BR.NRLANBOLREC  = :P_NRLANBOLREC) OR (BR.NRORIGBOLREC = :P_NRORIGBOLREC)
    AND BR.NRORG = :P_NRORG)

SQL;
        $params = array(
            "P_NRORG"        => $nrorg,
            "P_NRLANBOLREC"     => $nrlanbolrec,
            "P_CDFILIAL"   => $cdfilial,
            "P_NRORIGBOLREC" => $nrorigbolrec,
        );
    return $this->getEntityManager()->getConnection()->fetchAll($sql, $params);
    }

    public function getMaxCntParcReceber($nrorg, $cdfilial, $nrlanctonf, $nrseqvenrec){
        $sql = <<<SQL
        SELECT
           MAX(NRPARCELAREC) AS MAXNRPARCREC
        FROM
           CONTARECEBER
        WHERE
           CDFILIAL    = :P_CDFILIAL    AND
           NRLANCTONF  = :P_NRLANCTONF  AND
           NRSEQVENREC = :P_NRSEQVENREC AND
           NRORG       = :P_NRORG

SQL;
        $params = array(
            "P_NRORG"        => $nrorg,
            "P_NRLANCTONF"     => $nrlanctonf,
            "P_CDFILIAL"   => $cdfilial,
            "P_NRSEQVENREC" => $nrseqvenrec,
        );

     return $this->getEntityManager()->getConnection()->fetchAll($sql, $params);
    }

    public function getAjusteConta($cdfilibolrec,$nrlanbolrec,$nrorg){
        $sql = <<<SQL
SELECT
   AR.CDFILIAL,
   AR.NRLANCTONF,
   AR.NRSEQVENREC,
   AR.NRPARCELAREC,
   AR.DTAJUSTEREC,
   AR.DSAJUSTEREC,
   AR.CDAJUCTREC,
   TA.IDAJUCTREC,
   AR.CDCLASSFINA,
   AR.CDEMMFAJCNTR,
   AR.CDFIMFAJCNTR,
   AR.DTMOVFLUXO,
   AR.IDMOVFLUXO,
   AR.VRAJUSTEREC,
   AR.NRORG
FROM
   AJCTRECEBER   AR,
   TIPOAJRECEBER TA,
   CONTARECEBER  CT
WHERE
   (CT.CDFILIBOLREC = :P_CDFILIBOLREC) AND
   (CT.NRLANBOLREC  = :P_NRLANBOLREC)  AND
   (AR.CDFILIAL     = CT.CDFILIAL)     AND
   (AR.NRLANCTONF   = CT.NRLANCTONF)   AND
   (AR.NRSEQVENREC  = CT.NRSEQVENREC)  AND
   (AR.NRPARCELAREC = CT.NRPARCELAREC) AND
   (TA.CDAJUCTREC   = AR.CDAJUCTREC)   AND
   (CT.NRORG        = :P_NRORG)


SQL;
        $params = array(
            "P_NRORG"        => $nrorg,
            "P_NRLANBOLREC"     => $nrlanbolrec,
            "P_CDFILIBOLREC"   => $cdfilibolrec,

        );

        return $this->getEntityManager()->getConnection()->fetchAll($sql, $params);
    }

    public function getValorRateioConta($cdfilial,$nrlanctonf,$nrseqvenrec,$nrparcelarec,$nrorg){
        $sql = <<<SQL
   SELECT
   RATCTRECEBER.CDFILIAL,
   RATCTRECEBER.NRLANCTONF,
   RATCTRECEBER.NRSEQVENREC,
   RATCTRECEBER.NRPARCELAREC,
   RATCTRECEBER.CDCENTCUST,
   RATCTRECEBER.CDFIRATCTREC,
   RATCTRECEBER.VRRATCCCTREC,
   CONTARECEBER.VRATUAREC,
   ((RATCTRECEBER.VRRATCCCTREC * 100)/CONTARECEBER.VRATUAREC) AS NRPERCENTUAL
FROM
   RATCTRECEBER,
   CONTARECEBER
WHERE
   RATCTRECEBER.CDFILIAL     = :P_CDFILIAL               AND
   RATCTRECEBER.NRLANCTONF   = :P_NRLANCTONF             AND
   RATCTRECEBER.NRSEQVENREC  = :P_NRSEQVENREC            AND
   RATCTRECEBER.NRPARCELAREC = :P_NRPARCELAREC           AND
   RATCTRECEBER.NRORG        = :P_NRORG                  AND
   RATCTRECEBER.CDFILIAL     = CONTARECEBER.CDFILIAL     AND
   RATCTRECEBER.NRLANCTONF   = CONTARECEBER.NRLANCTONF   AND
   RATCTRECEBER.NRSEQVENREC  = CONTARECEBER.NRSEQVENREC  AND
   RATCTRECEBER.NRPARCELAREC = CONTARECEBER.NRPARCELAREC



SQL;
        $params = array(
            "P_NRORG"        => $nrorg,
            "P_NRLANCTONF"     => $nrlanctonf,
            "P_NRSEQVENREC"   => $nrseqvenrec,
            "P_NRPARCELAREC"  => $nrparcelarec,
            "P_CDFILIAL"      =>$cdfilial,
        );

        return $this->getEntityManager()->getConnection()->fetchAll($sql, $params);
    }

    public function getBoletoDup($nrorg,$cdfilibolrec,$nrlanbolrec){
         $sql = <<<SQL
 SELECT DISTINCT CDFILIALDUP, NRLANCTODUP
FROM CONTARECEBER
WHERE
   (CDFILIBOLREC = :P_CDFILIBOLREC) AND
   (NRLANBOLREC  = :P_NRLANBOLREC)  AND
   (NRORG        = :P_NRORG)        AND  
   (NOT CDFILIALDUP IS NULL)        AND
   (NOT NRLANCTODUP IS NULL)

UNION ALL

SELECT CDFILIALDUP, NRLANCTODUP
FROM CONTARECEBER
WHERE
   (CDFILIBOLREC = :P_CDFILIBOLREC) AND
   (NRLANBOLREC  = :P_NRLANBOLREC)  AND
   (NRORG        = :P_NRORG)        AND
   (CDFILIALDUP IS NULL)            AND
   (NRLANCTODUP IS NULL)

SQL;
        $params = array(
            "P_NRORG"        => $nrorg,
            "P_CDFILIBOLREC"     => $cdfilibolrec,
            "P_NRLANBOLREC"   => $nrlanbolrec,        
        );

        return $this->getEntityManager()->getConnection()->fetchAll($sql, $params);

    }

    public function getValorBoletoDup($nrorg,$cdfilialdup,$nrlanctodup)
    {

       $sql = <<<SQL
               SELECT
   SUM(VRATUAREC) VRATUAREC
FROM
   CONTARECEBER
WHERE
   (CDFILIALDUP = :P_CDFILIALDUP)  AND
   (NRLANCTODUP = :P_NRLANCTODUP)  AND
   (NRORG       = :P_NRORG)
SQL;
               
       $params = array(
                      "P_NRORG"        => $nrorg,
                      "P_CDFILIALDUP"     => $cdfilialdup,
                      "P_NRLANCTODUP"   => $nrlanctodup,        
                      );

        return $this->getEntityManager()->getConnection()->fetchAll($sql, $params);
 
    }

    public function getAjBolDup($nrorg,$cdfilial,$nrlanctodup){
      $sql = <<<SQL
               SELECT
   SUM(VRAJDUPBOLET) VRAJDUPBOLET
FROM
(SELECT
   A.VRAJDUPBOLET
FROM
   AJDUPBOLET    A,
   TIPOAJRECEBER T
WHERE
   (A.CDFILIAL    = :P_CDFILIAL)    AND
   (A.NRLANCTODUP = :P_NRLANCTODUP) AND
   (NRORG        = :P_NRORG)        AND
   (T.CDAJUCTREC  = A.CDAJUCTREC)   AND
   (T.IDAJUCTREC  = 'A')

UNION ALL

SELECT
   A.VRAJDUPBOLET * -1 VRAJDUPBOLET
FROM
   AJDUPBOLET    A,
   TIPOAJRECEBER T
WHERE
   (A.CDFILIAL    = :P_CDFILIAL)    AND
   (A.NRLANCTODUP = :P_NRLANCTODUP) AND
   (NRORG        =  :P_NRORG)        AND
   (T.CDAJUCTREC  = A.CDAJUCTREC)   AND
   (T.IDAJUCTREC  = 'D'))
   

SQL;
     $params = array(
                     "P_NRORG"        => $nrorg,
                     "P_CDFILIAL"     => $cdfilial,
                     "P_NRLANCTODUP"   => $nrlanctodup,        
                     );
     return $this->getEntityManager()->getConnection()->fetchAll($sql, $params);



    }
    public function getAjbolDupAux($cdfilial,$nrlanctodup,$cdfilibolrec,$nrlanbolrec,$nrorg){
       $sql = <<<SQL
       SELECT
   AD.CDAJUCTREC,
   AD.VRAJDUPBOLET
FROM
   AJDUPBOLET AD,
   AJBOLREC   AB
WHERE
   (AD.CDFILIAL    = :P_CDFILIAL)     AND
   (AD.NRLANCTODUP = :P_NRLANCTODUP)  AND
   (AB.CDFILIAL    = :P_CDFILIBOLREC) AND
   (AB.NRLANBOLREC = :P_NRLANBOLREC)  AND
   (AB.NRORG       = :P_NRORG)        AND   
   (AB.CDAJUCTREC  = AD.CDAJUCTREC)

SQL;
      $params = array(
                     "P_CDFILIAL"      => $cdfilial,
                     "P_NRLANCTODUP"   => $nrlanctodup,
                     "P_CDFILIBOLREC"  => $cdfilibolrec, 
                     "P_NRLANBOLREC"   => $nrlanbolrec,
                     "P_NRORG"         =>$nrorg,      
                     );
      return $this->getEntityManager()->getConnection()->fetchAll($sql, $params);

    }
    
    public static function deleteBoleto($nrorg, $nrlanbolrec)
    {   
    	$sql = <<<SQL
               		DELETE FROM BOLETRECEBER WHERE NRLANBOLREC = '$nrlanbolrec' AND NRORG = '$nrorg'
SQL;
    	return \Setforms2\Shared\Registry::getEntityManager()->getConnection()->exec($sql);
    }

    public function getNossoNumero($cdnosnumrec, $cdempresa){
        $sql = <<<SQL
                  SELECT
                       *
                    FROM
                       BOLETRECEBER
                    WHERE
                       replace(REPLACE(CDNOSNUMREC,'-',''), ' ', '')  = :P_CDNOSNUMREC AND
                       CDEMPRESA = :P_CDEMPRESA
SQL;
        $params = array(
            "P_CDNOSNUMREC" => $cdnosnumrec,
            "P_CDEMPRESA"   => $cdempresa
        );

        return $this->getEntityManager()->getConnection()->fetchAll($sql, $params);
    }

    public function getTxBoleto($cdfilial, $nrlanbolrec){
        $sql = <<<SQL
                SELECT TXMENSBOLBOL
                  FROM BOLETRECEBER
                 WHERE (CDFILIAL    = :CDFILIAL   ) AND
                      (NRLANBOLREC = :NRLANBOLREC)
SQL;
        $params = array(
            'CDFILIAL' => $cdfilial,
            'NRLANBOLREC' => $nrlanbolrec
        );

        return $this->getEntityManager()->getConnection()->fetchAll($sql, $params);

    }

    public function getDuplicata($cdfilial, $nrlanbolrec){
        $sql = <<<SQL
                SELECT DECODE(CR.NRPARCELAREC, '00', CR.NRSEQVENREC, CR.NRPARCELAREC) AS NRPARCELA,
                       NVL(DP.NRDUPLICATA, NF.NRNOTAFISC) AS DUPLICATA,
                       DTEMISSAO
                  FROM DUPLICATA DP, CONTARECEBER CR, NOTAFISCAL NF
                 WHERE (NF.CDFILIAL     = CR.CDFILIAL      ) AND
                      (NF.NRLANCTONF   = CR.NRLANCTONF    ) AND
                      (CR.CDFILIALDUP  = DP.CDFILIAL   (+)) AND
                      (CR.NRLANCTODUP  = DP.NRLANCTODUP(+)) AND
                      (CR.NRLANBOLREC  = :P_NRLANBOLREC   ) AND
                      (CR.CDFILIBOLREC = :P_CDFILIAL      )
SQL;
        $params = array(
            'P_CDFILIAL' => $cdfilial,
            'P_NRLANBOLREC' => $nrlanbolrec
        );

        return $this->getEntityManager()->getConnection()->fetchAll($sql, $params);

    }

    //Consulta os boletos que estao relacionados com o cheque utilizado
    public static function consultaBoletosRec($nrcheque,$cdbancocheque,$cdagenciacheque,$cdcontcorr, $nrorg) {
        $sql = "SELECT DISTINCT 'N' AS IDMARCADO, BO.CDFILIAL, BO.NRLANBOLREC, BO.CDCLIENTE,
                                       CL.NMFANTCLIE, CL.NRINSJURCLIE,CL.NMRAZSOCCLIE, CL.IDTPIJURCLIE,
                                       BO.VRFINALBREC, TR.NMTPBAIXAREC, BO.NRBAIXAREC, BO.DTVENBOLREC,
                                       BO.VRBOLREC, BO.CDNOSNUMREC, BO.IDSITUCNABR, BO.CDREDUCONT,
                                       BO.CDFILIBAIREC, BO.CDEMPRESA, BO.CDMOTIPARC, BO.IDSTATBREC,
                                       BO.NRORIGBOLREC, SUM(TB.VRTPRECBOLR) VRTPRECBOLR
                  FROM CLIENTE CL, BOLETRECEBER BO, TPRECBOLETO TB, TIPOBAIXAREC TR
                 WHERE (TB.NRCHEQBOLREC = :NRCHEQUE)
                   AND (TB.CDBANCBOLREC   = :CDBANCOCHEQUE)
                   AND (TB.CDAGENBOLREC   = :CDAGENCIACHEQUE)
                   AND (TB.CDCONTBOLREC   = :CDCONTCORR)
                   AND (TB.NRORG          = :NRORG)
                   AND (TB.CDFILIAL       = BO.CDFILIAL)
                   AND (TB.NRLANBOLREC    = BO.NRLANBOLREC)
                   AND (TB.NRORG          = BO.NRORG)
                   AND (BO.CDCLIENTE      = CL.CDCLIENTE)
                   AND (BO.NRORG          = CL.NRORG)
                   AND (BO.CDTPBAIXAREC   = TR.CDTPBAIXAREC(+))
                   AND (BO.NRORG          = TR.NRORG(+))
              GROUP BY BO.CDFILIAL, BO.NRLANBOLREC, BO.CDCLIENTE, CL.NMFANTCLIE, CL.NRINSJURCLIE,
                       CL.NMRAZSOCCLIE, CL.IDTPIJURCLIE, BO.VRFINALBREC, TR.NMTPBAIXAREC,
                       BO.NRBAIXAREC, BO.DTVENBOLREC, BO.VRBOLREC, BO.CDNOSNUMREC, BO.IDSITUCNABR,
                       BO.CDREDUCONT, BO.CDFILIBAIREC, BO.CDEMPRESA, BO.CDMOTIPARC, BO.IDSTATBREC,
                       BO.NRORIGBOLREC
              ORDER BY BO.DTVENBOLREC, CL.NMRAZSOCCLIE, BO.VRFINALBREC, BO.CDFILIAL, BO.NRLANBOLREC";

        $params = array('NRCHEQUE' => $nrcheque,
                        'CDBANCOCHEQUE' => $cdbancocheque,
                        'CDAGENCIACHEQUE' => $cdagenciacheque,
                        'CDCONTCORR' => $cdcontcorr,
                        'NRORG'      => $nrorg);

        try{
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $params);
        } catch(\Exception $e) {
            throw $e;
        }
    }
   
}

